/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#ifndef LS_STD_EVENT_MANAGER_REWORKED_HPP
#define LS_STD_EVENT_MANAGER_REWORKED_HPP

#include "Event.hpp"
#include <ls-std/core/Class.hpp>

namespace ls::std::event::reworked
{
  class EventManager : public ls::std::core::Class
  {
    public:

      explicit EventManager();
      ~EventManager() noexcept override;

      void invoke(const ls::std::event::reworked::Event &_event) const;
  };
}

#endif
