/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#include <gtest/gtest.h>
#include <ls-std-event-test.hpp>
#include <ls-std/ls-std-event.hpp>

using ls::std::event::reworked::EventManager;
using ::std::make_shared;
using test::event::Button;
using test::event::OnClickEvent;
using testing::Test;

namespace
{
  class EventManagerTest : public Test
  {
    public:

      EventManagerTest() = default;
      ~EventManagerTest() override = default;
  };

  TEST_F(EventManagerTest, getClassName)
  {
    ASSERT_STREQ("EventManager", EventManager().getClassName().c_str());
  }

  //TEST_F(EventManagerTest, invoke)
  //{
  //  auto eventManager = make_shared<EventManager>();
  //
  //  auto myButton = make_shared<Button>();
  //  myButton->subscribe(OnClickEvent().of(eventManager), [myButton] () mutable { myButton->onClickEvent(); });
  //
  //  ASSERT_FALSE(myButton->isClicked());
  //  eventManager->invoke(OnClickEvent());
  //  ASSERT_TRUE(myButton->isClicked());
  //}
}
