/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#ifndef LS_STD_EVENT_LISTENER_REWORKED_HPP
#define LS_STD_EVENT_LISTENER_REWORKED_HPP

#include <ls-std/core/Class.hpp>
#include <ls-std/event/reworked/Event.hpp>
#include <ls-std/event/reworked/type/EventTypes.hpp>

namespace ls::std::event::reworked
{
  class EventListener : public ls::std::core::Class
  {
    public:

      explicit EventListener();
      ~EventListener() noexcept override;

      void subscribe(const ls::std::event::reworked::Event &_event, const ls::std::event::reworked::type::EventAction &_action);
  };
}

#endif
