/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#include <gtest/gtest.h>
#include <ls-std/ls-std-event.hpp>

using ls::std::event::reworked::EventListener;
using testing::Test;

namespace
{
  class EventListenerTest : public Test
  {
    public:

      EventListenerTest() = default;
      ~EventListenerTest() override = default;
  };

  TEST_F(EventListenerTest, getClassName)
  {
    ASSERT_STREQ("EventListener", EventListener().getClassName().c_str());
  }
}
