/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#include <gtest/gtest.h>
#include <ls-std/ls-std-event.hpp>

using ls::std::event::reworked::Event;
using testing::Test;

namespace
{
  class EventTest : public Test
  {
    public:

      EventTest() = default;
      ~EventTest() override = default;
  };

  TEST_F(EventTest, getClassName)
  {
    ASSERT_STREQ("OnClickEvent", Event("OnClickEvent").getClassName().c_str());
  }
}
